package ru.landgrafhomyak.utility.highlevel_try_finally

import kotlin.contracts.InvocationKind
import kotlin.contracts.contract

class TryFinallyChainScope @PublishedApi internal constructor() {
	@PublishedApi
	internal var _actualException: Throwable? = null

	@PublishedApi
	internal fun _throw() {
		this._actualException?.let { e -> throw e }
	}

	inline fun action(fn: () -> Unit) {
		contract {
			callsInPlace(fn, InvocationKind.EXACTLY_ONCE)
		}
		safeAutoClose3e(
			onCrossReturn = { throw Error("Cross return not allowed in tryFinallyChain{action{}}") },
			onError = { err -> this._actualException?.addSuppressed(err) ?: run { this._actualException = err } },
			action = fn
		)
	}
}