@file:Suppress("unused")
@file:JvmName("TryFinallyChainKt")

package ru.landgrafhomyak.utility.highlevel_try_finally

import kotlin.contracts.InvocationKind
import kotlin.contracts.contract
import kotlin.jvm.JvmName

inline fun tryFinallyChain(chains: (TryFinallyChainScope) -> Unit) {
	contract {
		callsInPlace(chains, InvocationKind.EXACTLY_ONCE)
	}

	val scope = TryFinallyChainScope()
	safeAutoClose3e(
		onCrossReturn = { throw Error("Cross return not allowed in tryFinallyChain{}") },
		onError = { err -> throw Error("Unexpected exception in tryFinallyChain{}; calling anything outside action{} block isn't allowed", err) },
		onSuccess = { scope._throw() },
		action = { chains(scope) }
	)
}